import time
from gi.repository import GObject, RB, Peas

class RhythmBoxFix(GObject.Object, Peas.Activatable):
	object = GObject.property(type=GObject.Object)
	
	def __init__(self):
		super(RhythmBoxFix, self).__init__()
	
	def do_activate(self):
		self.shell = self.object
		self.player = self.shell.props.shell_player
		self.lastFixed = 0.
		self.connection = self.player.connect('playing-song-changed', self.theFix)
	
	def do_deactivate(self):
		if self.connection != None:
			self.player.disconnect(self.connection)
		self.shell = None
		self.player = None
		self.connection = None
		self.lastFixed = None
	
	def theFix(self, player, entry):
		if time.time() - self.lastFixed > 1:
			time.sleep(.05)
			self.player.do_previous()
			
			time.sleep(.05)
			self.player.do_next()
			
			self.lastFixed = time.time()

